<?php
if (!file_exists('conf.php')) {
	Header ('Location: setup/');
	exit();
}

$start_time = microtime();
include ('conf.php');
include ('include/inc_functions.php');

require_once ('include/inc_mysql.php');

session_start();

$p = $act = $item = $warning = $redirect = NULL;

if (isset($_GET['p']))
	$p = $_GET['p'];
if (isset($_GET['item']))
	$item = addslashes($_GET['item']);
if (isset($_GET['act']))
	$act = $_GET['act'];
if (isset($_GET['set_lang'])) {
	SetupLang($_GET['set_lang']);
	$_SESSION['user_lang'] = $_GET['set_lang'];
} else {
	if (isset($_SESSION['user_lang']))
		SetupLang($_SESSION['user_lang']);
	else
		SetupLang($SetDisplayLang);
}

// MySQL database connection
$db = new MySQL($db_access['host'], $db_access['database'], $db_access['username'], $db_access['password']);

// Check for admin privileges
$html = gettext('access_denied');

if (isset($_SESSION['session_key'])) {
	$hash_key = $_SESSION['session_key'];
	$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
	if ($db->num_rows($q0) == 1) {
		$var = $db->assoc($q0);
		if ($var['is_admin'] && !$var['dir'])
			$html = NULL;
	}
}

if ($html) { // User is not admin
	include('include/inc_header.php');
	$nav = '<p>' . display_nav($p, $UploadDir) . ' > admin</p><br />' . "\n";
	echo ($nav);
	include('include/inc_text_zone.php');
	include('include/inc_footer.php');
	exit();
}

switch ($act) {
case 'users':
	$title = 'Manage users';
	if ($item) {
		$q0 = $db->query("SELECT name, passwd, email, dir, is_admin FROM cgd_users WHERE id = '$item'");
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			$name = $var['name'];
			$email = $var['email'];
			$path = $var['dir'];
			$is_admin = $var['is_admin'];

			if($_POST) {
				if (isset($_POST['delete'])) {
					$q0 = $db->query("DELETE FROM cgd_users WHERE id = '$item'");
					$html = '<p>User successfully removed.<br /><br />[<a href="admin.php?act=users">Return to user admin</a>]</p>' . "\n";
				} else {
					if (($email = $_POST['email']) != $var['email'])
						$html = 'E-mail changed!<br />';

					if (($dir = $_POST['path']) != $var['dir'])
						$html .= 'Path changed!<br />';

					if ($_POST['pw']) {
						$pw = md5($_POST['pw']);
						$html .= 'Password changed!<br />';
					} else {
						$pw = $var['passwd'];
					}

					if (isset($_POST['is_admin']))
						$is_admin = 1;
					else
						$is_admin = 0;

					if ($is_admin != $var['is_admin'])
						$html .= 'Status changed!<br />';

					if (!$html)
						$html = 'No changes were made.<br />';

					$html = '<p>' . $html . '<br />[<a href="admin.php?act=users">Return to user admin</a>]</p>';

					$q0 = $db->query("UPDATE cgd_users SET passwd = '$pw', email = '" . addslashes($email) . "', dir = '" . addslashes($dir) . "', is_admin = '$is_admin' WHERE id = '$item'");
				}
				
				break;
			}

			include('include/inc_header.php');
			$nav = '<p> <a href="./">Home</a> > <a href="admin.php">admin</a> > <a href="admin.php?act=users">user management</a></p><br />' . "\n";
			echo ($nav);
			include('include/inc_admin_user_form.php');
			include('include/inc_footer.php');
			exit();
		} else {
			$html = '<p>User not found.</p>';
		}
	} else {
		$html = "<p>Select the user you wish to manage:</p>\n";
		$html .= "<ul>\n";
		$q0 = $db->query('SELECT id, name, is_admin FROM cgd_users');
		while ($var = $db->assoc($q0)) {
			$html .= '<li><p><a href="admin.php?act=users&amp;item=' . $var['id'] . '">' . $var['name'] . '</a> [Account type: ';
			if ($var['is_admin'])
				$html .= 'admin';
			else
				$html .= 'normal';

			$html .= ']</p></li>' . "\n";
		}

		$html .= "</ul>\n";
	}
	break;

case 'shares':
	$title = 'Manage shared folders';
	if ($item) {
		$q0 = $db->query("SELECT end_date, uses_left, ip, is_admin, can_create_account FROM cgd_access WHERE id = '$item'");
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);

			if($_POST) {
				if (isset($_POST['delete'])) {
					$q0 = $db->query("DELETE FROM cgd_access WHERE id = '$item'");
					$html = '<p>Share successfully removed.<br /><br />[<a href="admin.php?act=shares">Return to shared folder admin</a>]</p>' . "\n";
				} else {
					$html = 'Expire date updated!<br />';

					if ($_POST['access_limit'] != $var['uses_left'])
						$html .= 'Access limit changed!<br />';

					if (isset($_POST['ip_limit']))
						$ip_limit = NULL;
					else
						$ip_limit = '0.0.0.0';

					if (($var['ip'] != '0.0.0.0' && $ip_limit == '0.0.0.0') ||  ($var['ip'] == '0.0.0.0' && !$ip_limit))
						$html .= 'IP strategy changed!<br />';

					if (isset($_POST['is_admin']))
						$is_admin = 1;
					else
						$is_admin = 0;

					if ($is_admin != $var['is_admin'])
						$html .= 'Administrating strategy changed!<br />';

					if (isset($_POST['new_account']))
						$new_account = 1;
					else
						$new_account = 0;

					if ($new_account != $var['can_create_account'])
						$html .= 'Account creation strategy changed!<br />';

					$end_date = 60 * $_POST['mins'] + 3600 * $_POST['hours'] + 86400 * $_POST['days'] + time();

					if (!$html)
						$html = 'No changes were made.<br />';

					$html = '<p>' . $html . '<br />[<a href="admin.php?act=shares">Return to share admin</a>]</p>';

					$q0 = $db->query("UPDATE cgd_access SET end_date = '$end_date', uses_left = '" . $_POST['access_limit'] . "', ip = '$ip_limit', is_admin = '$is_admin', can_create_account = '$new_account' WHERE id = '$item'");
				}
				
				break;
			}

			$allow_delete = true;
			$ip_checked = $admin_checked = $new_checked = NULL;
			$action = 'admin.php?act=shares&amp;item=' . $item;

			$expire = $var['end_date'] - time();
			$expire -= ($days = floor($expire/60/60/24))*60*60*24;
			$expire -= ($hours = floor($expire/60/60))*60*60;
			if (($mins = floor($expire/60)) < 0 || $hours < 0 || $days < 0)
				$days = $hours = $mins = 0;

			$access_limit = $var['uses_left'];

			if ($var['ip'] != '0.0.0.0')
				$ip_checked = 'checked="checked" ';
			if ($var['is_admin'])
				$admin_checked = 'checked="checked" ';
			if ($var['can_create_account'])
				$new_checked = 'checked="checked" ';

			include('include/inc_header.php');
			include('include/inc_javascript_popup.php');
			$nav = '<p> <a href="./">Home</a> > <a href="admin.php">admin</a> > <a href="admin.php?act=shares">share management</a></p><br />' . "\n";
			echo ($nav);
			include('include/inc_new_share_form.php');
			include('include/inc_footer.php');
			exit();
		} else {
			$html = '<p>Share cannot be found. It may have been removed.</p>';
		}
	} else {
		$html = "<p>Select the shared folder you wish to manage:</p>\n";

		$q0 = $db->query('SELECT id, end_date, hash, dir FROM cgd_access WHERE user_account is null');

		if ($db->num_rows($q0)) {
			$html .= "<ul>\n";

			while ($var = $db->assoc($q0)) {
				$html .= '<li><p><a href="admin.php?act=shares&amp;item=' . $var['id'] . '">';
				if ($var['dir'])
					$html .= $var['dir'];
				else
					$html .= '[total access]';

				$html .= '</a> <a href="./?key=' . $var['hash'] . '">[key]</a> [expires in: ';
				$expire = $var['end_date'] - time();
				if ($expire <= 0) {
					$html .= 'share has already expired!';
				} else {
					if (($days = floor($expire/60/60/24)) != 0)
						$html .= "$days days";
					$expire -= $days*60*60*24;
					if (($hours = floor($expire/60/60)) != 0) {
						if ($days)
							$html .= ', ';
						$html .= "$hours hours";
					}
					$expire -= $hours*60*60;
					if (($minutes = floor($expire/60)) != 0) {
						if ($hours || $days)
							$html .= ' and';
						$html .= " $minutes minutes";
					}

					if (!$days && !$hours && !$minutes)
						$html .= 'less than a minute';
				}
				$html .= ']</p></li>' . "\n";
			}

			$html .= "</ul>\n";
		} else {
			$html = '<p>There are no shared folders to manage.<br /><br >[<a href="admin.php">Return to admin</a>]</p>';
		}
	}
	break;

case 'new_account':
	$warning = 'This will create a normal user with complete access to the shared space.';
	$name = $email = NULL;
	$action = 'admin.php?act=new_account';
	if($_POST) {
		$name = $_POST['name'];
		$email = $_POST['email'];
		$pw1 = $_POST['pw1'];
		$pw2 = $_POST['pw2'];
		if ($name && $email && $pw1 && $pw2) {
			if ($pw1 == $pw2) {
				$q0 = $db->query("SELECT id FROM cgd_users WHERE name = '" . addslashes($name) . "'");
				if (!$db->num_rows($q0)) {
					$pw1 = md5($pw1);
					$q0 = $db->query("INSERT INTO cgd_users VALUES ('', '" . addslashes($name) . "', '$pw1', '" . addslashes($email) . "', '', '0')");
					$warning = NULL;
					$title = gettext('new_account');
					$html = '<p>' . gettext('account_creation_successful') . '<br /><br />[<a href="admin.php">' . gettext('continue') . '</a>]</p>';
					break;
				} else { // Le compte existe deja
					$warning = gettext('duplicated_account');
				}
			} else {
				$warning = gettext('different_pw');
			}
		} else {
			$warning = gettext('empty_fields');
		}
	}


	include('include/inc_header.php');
	$nav = '<p> <a href="./">Home</a> > <a href="admin.php">admin</a> > <a href="admin.php?act=new_account">' . gettext('new_account') . '</a></p><br />' . "\n";
	echo ($nav);
	include('include/inc_new_account_form.php');
	include('include/inc_footer.php');
	exit();
	break;

default:
	$title = 'Admin home';
	$html = "<p>\n";
	$html .= 'Please choose the ressource you would like to administrate:<br /><br />' . "\n";
	$html .= '[<a href="admin.php?act=users">User management</a>] [<a href="admin.php?act=shares">Edit shares</a>] [<a href="admin.php?act=new_account">Create user account</a>]' . "\n";
	$html .= "</p>\n";
	break;
}

include('include/inc_header.php');
$nav = '<p>' . display_nav($p, $UploadDir) . ' > <a href="admin.php">admin</a></p><br />' . "\n";
echo ($nav);
include('include/inc_admin_zone.php');
include('include/inc_footer.php');
?>