<?php
if (!file_exists('conf.php')) {
	Header ('Location: setup/');
	exit();
}

$start_time = microtime();
include ('conf.php');
include ('include/inc_functions.php');

require_once ('include/inc_mysql.php');

session_start();

$p = $hash_key = $act = $html = $warning = $redirect = NULL;
$access_ok = false;

if (isset($_GET['p']))
	$p = $_GET['p'];
if (isset($_GET['key']))
	$hash_key = addslashes($_GET['key']);
if (isset($_GET['act']))
	$act = $_GET['act'];
if (isset($_GET['set_lang'])) {
	SetupLang($_GET['set_lang']);
	$_SESSION['user_lang'] = $_GET['set_lang'];
} else {
	if (isset($_SESSION['user_lang']))
		SetupLang($_SESSION['user_lang']);
	else
		SetupLang($SetDisplayLang);
}

// On n'autorise pas les chemins '..'
if (preg_match('/\.\./', $p))
	$p = NULL;

// MySQL database connection
$db = new MySQL($db_access['host'], $db_access['database'], $db_access['username'], $db_access['password']);

// Effacer les entres primes
$current_time = time();
$q0 = $db->query("DELETE FROM cgd_access WHERE end_date < '$current_time'");

switch ($act) {
case 'hash_gen':
case 'hash_gen_do':
	$html = gettext('access_denied');
	$which_include = 'include/inc_text_zone.php';
	if (isset($_SESSION['session_key'])) {
		$hash_key = $_SESSION['session_key'];
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$ip_checked = $admin_checked = $new_checked = $allow_delete = NULL;
				$p = check_root_dir($var['dir'], $p);
				$action = '?act=hash_gen_do&amp;p=' . urlencode($p);
				if ($act == 'hash_gen') {
					$days = $mins = $hours = 0;
					$access_limit = 1;
					$which_include = 'include/inc_new_share_form.php';
				} else {
					$days = (int)$_POST['days'];
					$hours = (int)$_POST['hours'];
					$mins = (int)$_POST['mins'];
					$access_limit = (int)$_POST['access_limit'];
					$ip_limit = '0.0.0.0';
					$is_admin = $new_account = 0;

					if(isset($_POST['ip_limit']))
						$ip_limit = NULL;
					if (isset($_POST['is_admin']))
						$is_admin = 1;
					if (isset($_POST['new_account']))
						$new_account = 1;

					if (($days || $hours || $mins) && ($access_limit || $new_account)) {
						$current_time = time();
						$end_date = 60 * $mins + 3600 * $hours + 86400 * $days + $current_time;
						$hash = md5(microtime() + $start_time);
						$q0 = $db->query("INSERT INTO cgd_access VALUES ('', '$current_time', '$end_date', '$access_limit', '$hash', '" . addslashes($p) . "', '$ip_limit', '$is_admin', '$new_account', null)");

						$url = 'http://' . $_SERVER['HTTP_HOST'];
						if (dirname($_SERVER['PHP_SELF']) != '/')
							$url .= dirname($_SERVER['PHP_SELF']);
						$url .= "/?key=$hash";
						
						$html = gettext('hash_key_success') . "<a href=\"$url\">$url</a>";

					} else {
						$warning = gettext('empty_fields');
						$which_include = 'include/inc_new_share_form.php';
					}
				}
			}
		}
	}
	include('include/inc_header.php');
	include('include/inc_javascript_popup.php');
	$nav = '<p>' . display_nav($p, $UploadDir) . " > Administration</p><br />\n";
	echo ($nav);
	include($which_include);
	include('include/inc_footer.php');
	exit();
	break;

case 'upload_do':
	$hash_key = $_GET['session_key'];
case 'upload':
	if (!isset($session_id) && isset($_SESSION['session_key']))
		$hash_key = $_SESSION['session_key'];

	$html = gettext('access_denied');
	$which_include = 'include/inc_text_zone.php';
	if (isset($hash_key)) {
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$p = check_root_dir($var['dir'], $p);

				if ($act == 'upload') {
					$MaxFileUploadSize = str_replace('M', '', min(ini_get('post_max_size'), ini_get('upload_max_filesize')));
					$which_include = 'include/inc_upload_form_java.php';
				} else {
					foreach($_FILES as $tagname => $object) {
						umask(0);
						
						$filepath = $UploadDir . $p . $object['name'];

						if (file_exists($filepath)) {
							if (isset($upload_same_name))
								$upload_same_name .= ', ' . $object['name'];
							else
								$upload_same_name = $object['name'];
						} else {
							if (@move_uploaded_file($object['tmp_name'], $filepath)) {
								chmod($filepath, $SetChmod);
							} else {
								if (isset($upload_error))
									$upload_error .= ', ' . $object['name'];
								else
									$upload_error = $object['name'];
							}
						}
					}
					
					if (isset($upload_same_name))
						echo (gettext('upload_same_name') . '<br><br>' . $upload_same_name . '<br><br>');

					if (isset($upload_error))
						echo (gettext('upload_error') . '<br><br>' . $upload_error);

					if (!isset($upload_same_name) && !isset($upload_error))
						echo (gettext('upload_success'));
					exit();
				}	
			}
		}
	}
	include('include/inc_header.php');
	$nav = '<p>' . display_nav($p, $UploadDir) . " > Upload</p><br />\n";
	echo ($nav);
	include($which_include);
	include('include/inc_footer.php');
	exit();
	break;

case 'new_folder':
	$html = gettext('access_denied');
	$which_include = 'include/inc_text_zone.php';
	if (isset($_SESSION['session_key'])) {
		$hash_key = $_SESSION['session_key'];
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$p = check_root_dir($var['dir'], $p);

				if(isset($_POST['folder_name'])) {
					if (strpos($_POST['folder_name'], '/') !== false)
						$warning = gettext('folder_illegal_chars');
					if ($_POST['folder_name'] == '')
						$warning = gettext('folder_name_empty');
					
					if (!isset($warning)) {
						umask(0);
						$folder_name = $UploadDir . $p . $_POST['folder_name'];
						if(@mkdir($folder_name, $SetChmod))
							$html = gettext('folder_created') . '<br /><br />[<a href="?p=' . $p . '">' . gettext('continue') . '</a>]';
						else
							$warning = gettext('folder_error');
					}
				}

				if (isset($warning) || !isset($_POST['folder_name'])) {
					$folder_name = NULL;
					if (isset($_POST['folder_name']))
						$folder_name = $_POST['folder_name'];
					$which_include = 'include/inc_new_folder.php';
				}
			}
		}
	}
	include('include/inc_header.php');
	$nav = '<p>' . display_nav($p, $UploadDir) . ' > ' . gettext('new_folder') . "</p><br />\n";
	echo ($nav);
	include($which_include);
	include('include/inc_footer.php');
	exit();
	break;

case 'delete_do':
case 'delete':
	$html = gettext('access_denied');
	if (isset($_SESSION['session_key'])) {
		$hash_key = $_SESSION['session_key'];
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$p = check_root_dir($var['dir'], $p);

				if ($_GET['act'] == 'delete') {
					if (is_dir($UploadDir . $p))
						$html = gettext('confirm_delete_folder') . '<br /><br />[<a href="?act=delete_do&amp;p=' . $p . '">' . gettext('continue') . '</a>] [<a href="javascript:history.back()">' . gettext('cancel') . '</a>]';
					else
						$html = gettext('confirm_delete_file') . '<br /><br />[<a href="?act=delete_do&amp;p=' . $p . '">' . gettext('continue') . '</a>] [<a href="javascript:history.back()">' . gettext('cancel') . '</a>]';					
				} else {
					if (($dir_name = dirname($p) . '/') == './')
						$dir_name = NULL;

					if(erase_stuff($UploadDir . $p)) {
						$redirect = '?p=' . $dir_name;
						$html = gettext('delete_ok') . '<br /><br />' . gettext('redirect');
					} else {
						$html = gettext('delete_error') . '<br /><br />[<a href="?p=' . $dir_name . '">' . gettext('continue') . '</a>]';
					}
				}
			}
		}
	}
	include('include/inc_header.php');
	$nav = '<p>' . display_nav($p, $UploadDir) . ' > ' . gettext('delete') . "</p><br />\n";
	echo ($nav);
	include('include/inc_text_zone.php');
	include('include/inc_footer.php');
	exit();
	break;

case 'login':
	if (isset($_POST['name'])) {
		$warning = gettext('login_failed');
		$name = addslashes($_POST['name']);
		$pw = addslashes(md5($_POST['pw']));
		$q0 = $db->query("SELECT dir, is_admin FROM cgd_users WHERE name = '$name' AND passwd = '$pw'");
		if ($db->num_rows($q0) == 1) {
			$warning = FALSE;
			$var = $db->assoc($q0);
			$current_time = time();
			$end_date = 86400 + $current_time; // La clef expire aprs une journe
			$hash = md5(microtime() + $start_time);
			$p = addslashes($var['dir']);
			$is_admin = $var['is_admin'];
			$q0 = $db->query("INSERT INTO cgd_access VALUES ('', '$current_time', '$end_date', '-1', '$hash', '$p', '0.0.0.0', '$is_admin', '0', '$name')");
			$_SESSION['session_key'] = $hash;
		}
	}
	
	if (!$warning && isset($_POST['name'])) {
	    $redirect = './';
	}
	
	include('include/inc_header.php');
	$nav = '<p>' . display_nav('', $UploadDir) . " > Login</p><br />\n";
	echo ($nav);
	if ($warning || !isset($_POST['name'])) {
		include('include/inc_login_form.php');
	} else {
		$html = gettext('login_successful');
		include('include/inc_text_zone.php');
	}
	include('include/inc_footer.php');
	exit();
	break;

case 'help':
	include('include/inc_help.php');
	exit();
	break;

default:
	break;
}

// Vrifier si l'utilisateur vient de saisir une clef
if ($hash_key) {
	$q0 = $db->query("SELECT uses_left, dir, ip, is_admin, can_create_account FROM cgd_access WHERE hash = '$hash_key'");
	if ($db->num_rows($q0) == 1) {
		$var = $db->assoc($q0);
		$p = $var['dir'];
		if ($var['can_create_account']) {
		$html = $name = $email = NULL;
		$action = '?key=' . $hash_key;
			if ($_POST) {
				$name = $_POST['name'];
				$email = $_POST['email'];
				$pw1 = $_POST['pw1'];
				$pw2 = $_POST['pw2'];
				if ($name && $email && $pw1 && $pw2) {
					if ($pw1 == $pw2) {
						$q0 = $db->query("SELECT id FROM cgd_users WHERE name = '" . addslashes($name) . "'");
						if (!$db->num_rows($q0)) {
							$pw1 = md5($pw1);
							$is_admin = $var['is_admin'];
							$q0 = $db->query("INSERT INTO cgd_users VALUES ('', '" . addslashes($name) . "', '$pw1', '" . addslashes($email) . "', '" . addslashes($p) . "', '$is_admin')");
							$q0 = $db->query("DELETE FROM cgd_access WHERE hash = '$hash_key'");
							$html = gettext('account_creation_successful');
						} else { // Le compte existe deja
							$warning = gettext('duplicated_account');
						}
					} else {
						$warning = gettext('different_pw');
					}
				} else {
					$warning = gettext('empty_fields');
				}
			}
			include('include/inc_header.php');
			$nav = '<p>' . display_nav('', $UploadDir) . ' > ' . gettext('new_account') . "</p><br />\n";
			echo ($nav);
			if (!$html)
				include('include/inc_new_account_form.php');
			else
				include('include/inc_text_zone.php');
			include('include/inc_footer.php');
			exit();
		} else {
			$uses_left = $var['uses_left'];
			$ip = $var['ip'];
			if ($uses_left == 0) {
				$warning = gettext('stale_key');
			} else {
				if ($ip == '0.0.0.0') { // Pas de rstriction d'IP
					$client_ip = '0.0.0.0';
				} else {
					$client_ip = $_SERVER['REMOTE_ADDR'];
					if ($client_ip != $ip && $ip)
						$warning = gettext('wrong_ip');
				}
				if (!$warning) {
					if ($uses_left > 0)
						$uses_left--;
					$q0 = $db->query("UPDATE cgd_access SET uses_left = '$uses_left', ip = '$client_ip' WHERE hash = '$hash_key'");
					$_SESSION['session_key'] = $hash_key;
				}
			}
		}
	} else {
		$warning = gettext('invalid_key');
	}
}

// Vrifier la session
if (isset($_SESSION['session_key'])) {
	$hash_key = $_SESSION['session_key'];
	$q0 = $db->query("SELECT dir, is_admin FROM cgd_access WHERE hash = '$hash_key'");
	if ($db->num_rows($q0) == 1) {
		$var = $db->assoc($q0);
		//$id = $var['id'];
		$is_admin = $var['is_admin'];

		$p = check_root_dir($var['dir'], $p);

		$access_ok = 1;

	} else {
		$warning = gettext('stale_key');
	}
}

if ($access_ok) {
	$nav = NULL;

	$nav .= '<p>' . display_nav($p, $UploadDir) . "</p><br />\n";

	if ($is_admin) {
		$nav .= '<p class="main">' . gettext('admin_menu') . ' <a href="?act=hash_gen&amp;p=' . urlencode($p) . '" title="' . gettext('share_folder') . '">' . gettext('share') . '</a>, <a href="?act=upload&amp;p=' . urlencode($p) . '" title="' . gettext('upload_folder') . '">' . gettext('upload') . '</a>, <a href="?act=new_folder&amp;p=' . urlencode($p) . '" title="' . gettext('new_folder') . '">' . gettext('new_folder') . '</a>';
			if (!$var['dir']) // Super admin
				$nav .= ', <a href="admin.php">' . gettext('control_panel') . '</a>';
			$nav .= "</p><br />\n";
		}

	$dir = $UploadDir . $p;

	if (is_dir($dir)) {
		if ($dh = opendir($dir)) {
			while (($file = readdir($dh)) !== false) {
				if ($file != '.' && $file != '..') {
					$is_file = is_file($UploadDir . $p . $file);
					if ($is_file) {
						// Get file date
						$filedate = filemtime($UploadDir . $p . $file);
						
						// Display file date
						$creation_date = gettext('creation_date') . strftime("%Y/%m/%d %R:%S", $filedate);

						$html .= '<a href="?p=' . urlencode($p . $file) . '" title="' . $creation_date . '"><img alt="[DOWNLOAD]" src="images/dl_icon.gif" />';
					} else {
						$file .= '/';
						$html .= '<a href="?p=' . urlencode($p . $file) . '"><img alt="[DIR]" src="images/dir_icon.gif" />';
					}
					$html .= "<span class=\"textup\">$file</span></a>";
					if ($is_file) {
						$unit_bytes = gettext('bytes');
						$unit_bytes_short = gettext('bytes_short');
						$units = array(" $unit_bytes", "k$unit_bytes_short", "M$unit_bytes_short", "G$unit_bytes_short", "T$unit_bytes_short");
						$filesize = filesize($UploadDir . $p . $file);
						$i = 0;
						while ($filesize >= 1024) {
							$filesize /= 1024;
							$i++;
						}
						
						// Display file size
						$html .= '<span class="textup">[' . round($filesize, 1) . $units[$i] . ']</span>';
					}
					if (!$is_file && $is_admin)
						$html .= '<span class="textup">[<a href="?act=hash_gen&amp;p=' . urlencode($p.$file) . '">' . gettext('share_folder') . '</a>]</span>';
		
					if ($is_admin)
						$html .= '<span class="textup">[<a href="?act=delete&amp;p=' . urlencode($p.$file) . '" title="' . gettext('delete') . '">' . 'X' . '</a>]</span>';

					$html .= "<br />\n";
				}
			}
			closedir($dh);
		}
	} else {
		if (is_file($dir)) {
			send_file($dir);
			exit();
		} else {
			$html .= gettext('file_not_found');
		}
	}
	if (!$html)
		$html = gettext('empty_folder');
}

include('include/inc_header.php');
if ($access_ok) {
	echo ($nav);
	include('include/inc_text_zone.php');
} else {
	include('include/inc_hash_form.php');
}
include('include/inc_footer.php');
?>
